#include "robot.h"
#include <bits/stdc++.h>

using namespace std;

struct cell
{
    int i,j;
    cell(int i, int j) : i(i), j(j) {}
};

cell dir[4] = {{0,-1},{1,0},{0,1},{-1,0}};
char c[4] = {'W','S','E','N'};
int chi[4] = {2,4,6,8};

void go_to_parent(vector<int>s, int A)
{
    if(s[1]==-2 && s[4] == -2) set_instruction(s,A,'H');
    else set_instruction(s,A,c[s[0]/2 - 1]);
}

void make_bfs(vector<int>s)
{
    if(s[0] > 0)
    {
        if(s[0] % 2 == 0)
        {
            for(int z = 0; z < 4; z++)
            {
                if(z == s[0]/2 - 1) continue;
                if(s[z+1] < 0) continue;
                if(s[z+1] % 2 == 1) continue;
                if(!s[z+1] || abs((z) - (s[z+1]/2-1)) == 2) set_instruction(s,s[0],c[z]);
                return;
            }
            go_to_parent(s,s[0]+1);
        }
        else
        {
            for(int z = 0; z < 4; z++)
            {
                if(z == s[0]/2 - 1) continue;
                if(s[z+1] < 0) continue;
                if(s[z+1] % 2 == 0) continue;
                if(!s[z+1] || abs((z) - (s[z+1]/2-1)) == 2) set_instruction(s,s[0],c[z]);
                return;
            }
            go_to_parent(s,s[0]-1);
        }
    }
    else
    {
        int par = -1;
        for(int z = 0; z < 4; z++) if(par == -1 && s[z+1] > 0) par = z;
        set_instruction(s,chi[par]+1,c[par]);
    }
}

void listo_bottom(vector<int>s)
{
    if(s[2]==-2&&s[3]==-2) go_to_parent(s,1);
    else go_to_parent(s,0);
}

void dfs(vector<int>s)
{
    if(s[0] && s[0]%2==0)
    {
        set_instruction(s,s[0]+1,'H');/// 2 4 6 8
        return;
    }

    if(s[0] >= 3 && s[0]%2 == 1)/// 3 5 7 9
    {
        int br[2];
        for(int z = 0; z < 4; z++)
        {
            if(z == s[0]/2 - 1) continue;///parent
            if(s[z+1] < 0) continue;/// walls
            if(s[z+1] >= 3 && s[z+1]%2 == 1) continue;///USELESS
            if(s[z+1] < 2)
            {
                br[s[z+1]]++;
                continue; /// 0 1
            }
            if(abs((z) - (s[z+1]/2-1)) == 2) set_instruction(s,s[0]+1,c[z]);
            return;
        }
        if(br[0]+br[1])
        {
            if(br[1]) go_to_parent(s,1);
            else go_to_parent(s,0);
        }
        listo_bottom(s);

        if(s[1]==-2 && s[4]==-2) set_instruction(s,s[0],'T');
    }
}

void program_pulibot()
{
    vector<int>i;
    i.resize(5);
    if(true)
    {
        i[0] = 0;
        i[1] = i[4] = -2;
        for(i[2] = -1; i[2] <= 0; i[2]++)
        {
            for(i[3] = -1; i[3] <= 0; i[3]++) set_instruction(i,2,'H');
        }
    }

    for(i[0] = 0; i[0] <= 9; i[0]++) ///make_bfs_tree
    {
        for(i[1] = -2; i[1] <= 9; i[1]++)
        {
            for(i[2] = -2; i[2] <= 9; i[2]++)
            {
                for(i[3] = -2; i[3] <= 9; i[3]++)
                {
                    for(i[4] = -2; i[4] <= 9; i[4]++)
                    {
                        make_bfs(i);
                    }
                }
            }
        }
    }

    ///NEZNAM


    /**if(true)
    {
        i[0] = 2;
        i[1] = i[4] = -2;
        for(i[2] = -1; i[2] <= 8; i[2]++)
        {
            for(i[3] = -1; i[3] <= 8; i[3]++) set_instruction(i,3,'H');///pochvame s 3
        }
    }*/

    for(i[0] = 2; i[0] <= 9; i[0]++) ///make_ones
    {
        for(i[1] = -2; i[1] <= 9; i[1]++)
        {
            for(i[2] = -2; i[2] <= 9; i[2]++)
            {
                for(i[3] = -2; i[3] <= 9; i[3]++)
                {
                    for(i[4] = -2; i[4] <= 9; i[4]++)
                    {
                        dfs(i);
                    }
                }
            }
        }
    }
}
